---
title: XRInputSourceArray.entries()
slug: Web/API/XRInputSourceArray/entries
tags:
  - API
  - AR
  - Entries
  - Input Sources
  - Inputs
  - Iterator
  - Method
  - Reference
  - VR
  - WebXR
  - WebXR API
  - WebXR Device API
  - XR
  - XRInputSourceArray
---
<p>{{APIRef("WebXR Device API")}}{{SecureContext_header}}</p>

<p><span class="seoSummary">The {{domxref("XRInputSourceArray")}} interface's <code><strong>entries()</strong></code> method returns a JavaScript <code><a href="/en-US/docs/Web/JavaScript/Reference/Iteration_protocols">iterator</a></code> which can then be used to iterate over the key/value pairs in the input source array.</span> Each item in the array is an {{domxref("XRInputSource")}} object.</p>

<p>Most frequently, you will use this in tandem with statements such as <code><a href="/en-US/docs/Web/JavaScript/Reference/Statements/for...of">for...of</a></code>.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">let <em>inputSourceIterator</em> = <em>xrInputSourceArray</em>.entries();

for (let <em>entry</em> of <em>xrInputSourceArray</em>.entries()) {
  /* ... */
}
</pre>

<h3 id="Parameters">Parameters</h3>

<p>None.</p>

<h3 id="Return_value">Return value</h3>

<p>An <code><a href="/en-US/docs/Web/JavaScript/Reference/Iteration_protocols">iterator</a></code> which can be used to walk through the list of <code>XRInputSource</code> objects included in the input source array.</p>

<h2 id="Examples">Examples</h2>

<p>This example snippet gets the list of inputs for a session and tries to handle each type of input device it supports using.</p>

<pre class="brush: js">let sources = xrSession.inputSources;

for (let input of sources.entries()) {
  if (input.gamepad) {
    checkGamepad(input.gamepad);
  } else {
    if (input.targetRayMode === "tracked-pointer" &amp;&amp;
        input.handedness === player.handedness) {
      /* Handle main hand controller */
      handleMainHandInput(input);
    } else {
      /* Handle other inputs */
    }
  }
}
</pre>

<p>For each input in the llist, gamepad inputs are dispatched to a <code>checkGamepad()</code> with the input's {{domxref("Gamepad")}} object, taken from its {{domxref("XRInputSource.gamepad", "gamepad")}} property, as an input</p>

<p>For other devices, we look for <code>tracked-pointer</code> devices in the player's main hand, dispatching those to a <code>handleMainHandInput()</code> method.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('WebXR','#xrinputsourcearray','XRInputSourceArray')}}<sup><a href="#spec-iterables">1</a></sup></td>
   <td>{{Spec2('WebXR')}}</td>
   <td><code>XRInputSourceArray</code> interface</td>
  </tr>
 </tbody>
</table>

<p><a id="spec-iterables">[1]</a> See {{SectionOnPage("/en-US/docs/MDN/Contribute/Howto/Write_an_API_reference/Information_contained_in_a_WebIDL_file", "Iterator-like methods")}} for information on how an <code>iterable</code> declaration in an interface definition causes <code>entries()</code>, <code>forEach()</code>, <code>keys()</code>, and <code>values()</code> methods to be exposed from objects that implement the interface.</p>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.XRInputSourceArray.entries")}}</p>
